﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System.Drawing;

namespace WTM_ComboNoSelectedItemImage
{
    class CustomCreationFilter : IUIElementCreationFilter
    {

        public void AfterCreateChildElements(UIElement parent)
        {
            var editorWithText = parent as EditorWithTextUIElement;

            if (editorWithText == null)
                return;

            var comboBoxTool = editorWithText.GetContext(typeof(ComboBoxTool));

            if (comboBoxTool == null)
                return;

            var imageElement = editorWithText.GetDescendant(typeof(ImageUIElement));
            var textElement = editorWithText.GetDescendant(typeof(EditorWithTextDisplayTextUIElement));

            if (imageElement == null || textElement == null)
                return;

            editorWithText.ChildElements.Remove(imageElement);

            textElement.Rect = new Rectangle(editorWithText.Rect.X, editorWithText.Rect.Y,
                imageElement.Rect.Width + textElement.Rect.Width, textElement.Rect.Height);
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
